From 612a1c34777caf58247e26e97964be339b030d37 Mon Sep 17 00:00:00 2001
From: Benjamin Dauvergne <bdauvergne@entrouvert.com>
Date: Thu, 1 Oct 2020 07:56:17 +0200
Subject: [PATCH] manager: remove dubious non-breakable spaces in translatable
 strings (#47206)

---
 .../templates/authentic2/manager/role_members_table.html        | 2 +-
 .../templates/authentic2/manager/service_roles_table.html       | 2 +-
 .../templates/authentic2/manager/user_authorizations_table.html | 2 +-
 .../manager/templates/authentic2/manager/user_roles_table.html  | 2 +-
 4 files changed, 4 insertions(+), 4 deletions(-)

diff --git a/src/authentic2/manager/templates/authentic2/manager/role_members_table.html b/src/authentic2/manager/templates/authentic2/manager/role_members_table.html
index df3700cf..2702cf97 100644
--- a/src/authentic2/manager/templates/authentic2/manager/role_members_table.html
+++ b/src/authentic2/manager/templates/authentic2/manager/role_members_table.html
@@ -1,10 +1,10 @@
 {% extends "authentic2/manager/table.html" %}
 
 {% load i18n %}
 
   {% block table.head.last.column %}
     <th></th>
   {% endblock %}
   {% block table.tbody.last.column %}
-  <td class="remove-icon-column">{% if table.context.view.can_manage_members and row.record.direct %}<a class="js-remove-object" data-confirm="{% blocktrans with username=row.record.get_full_name role=table.context.object %}Do you really want to remove user &quot;{{ username }}&quot; from role &quot;{{ role }}&quot;&nbsp;?{% endblocktrans %}" href="#" data-pk-arg="user"><span class="icon-remove-sign"></span></a>{% endif %}</td>
+  <td class="remove-icon-column">{% if table.context.view.can_manage_members and row.record.direct %}<a class="js-remove-object" data-confirm="{% blocktrans with username=row.record.get_full_name role=table.context.object %}Do you really want to remove user &quot;{{ username }}&quot; from role &quot;{{ role }}&quot;?{% endblocktrans %}" href="#" data-pk-arg="user"><span class="icon-remove-sign"></span></a>{% endif %}</td>
   {% endblock %}
diff --git a/src/authentic2/manager/templates/authentic2/manager/service_roles_table.html b/src/authentic2/manager/templates/authentic2/manager/service_roles_table.html
index 7f4fe08d..d59b60d4 100644
--- a/src/authentic2/manager/templates/authentic2/manager/service_roles_table.html
+++ b/src/authentic2/manager/templates/authentic2/manager/service_roles_table.html
@@ -1,10 +1,10 @@
 {% extends "authentic2/manager/table.html" %}
 
 {% load i18n %}
 
   {% block table.head.last.column %}
     <th></th>
   {% endblock %}
   {% block table.tbody.last.column %}
-    <td class="remove-icon-column">{% if table.context.view.can_change %}<a class="js-remove-object" data-confirm="{% blocktrans with name=row.record.name slug=table.context.object %}Do you really want to remove role &quot;{{ name }}&quot; from service &quot;{{ slug }}&quot;&nbsp;?{% endblocktrans %}" href="#" data-pk-arg="role"><span class="icon-remove-sign"></span></a>{% endif %}</td>
+    <td class="remove-icon-column">{% if table.context.view.can_change %}<a class="js-remove-object" data-confirm="{% blocktrans with name=row.record.name slug=table.context.object %}Do you really want to remove role &quot;{{ name }}&quot; from service &quot;{{ slug }}&quot;?{% endblocktrans %}" href="#" data-pk-arg="role"><span class="icon-remove-sign"></span></a>{% endif %}</td>
   {% endblock %}
diff --git a/src/authentic2/manager/templates/authentic2/manager/user_authorizations_table.html b/src/authentic2/manager/templates/authentic2/manager/user_authorizations_table.html
index 3f879452..32a6f4ad 100644
--- a/src/authentic2/manager/templates/authentic2/manager/user_authorizations_table.html
+++ b/src/authentic2/manager/templates/authentic2/manager/user_authorizations_table.html
@@ -4,15 +4,15 @@
 
 {% block table.head.last.column %}
 <th></th>
 {% endblock %}
 
 {% block table.tbody.last.column %}
 <td class="remove-icon-column">
   <a class="{% if not table.context.view.can_manage_authorizations %} disabled {% else %} js-remove-object {% endif %}"
-     data-confirm="{% blocktrans with client=row.record.client username=table.context.object.get_full_name %}Do you really want to remove &quot;{{ client }}&quot; service granted access to &quot;{{ username }}&quot; profile data &nbsp;?{% endblocktrans %}"
+     data-confirm="{% blocktrans with client=row.record.client username=table.context.object.get_full_name %}Do you really want to remove &quot;{{ client }}&quot; service granted access to &quot;{{ username }}&quot; profile data?{% endblocktrans %}"
      href="#" data-pk-arg="auth_id">
     <span class="icon-remove-sign"></span>
   </a>
 </td>
 {% endblock %}
 
diff --git a/src/authentic2/manager/templates/authentic2/manager/user_roles_table.html b/src/authentic2/manager/templates/authentic2/manager/user_roles_table.html
index ecf2a96f..081242aa 100644
--- a/src/authentic2/manager/templates/authentic2/manager/user_roles_table.html
+++ b/src/authentic2/manager/templates/authentic2/manager/user_roles_table.html
@@ -3,12 +3,12 @@
 {% load i18n %}
 
   {% block table.head.last.column %}
     <th></th>
   {% endblock %}
   {% block table.tbody.last.column %}
   <td class="remove-icon-column">
     {% if table.context.view.can_change and row.record.member %}
-      <a class="{% if not row.record.can_manage_members %} disabled {% else %} js-remove-object {% endif %}" data-confirm="{% blocktrans with name=row.record.name username=table.context.object.get_full_name %}Do you really want to remove role &quot;{{ name }}&quot; from user &quot;{{ username }}&quot;&nbsp;?{% endblocktrans %}" href="#" data-pk-arg="role" title="{% if not row.record.can_manage_members %}{% trans "This role is synchronised from LDAP, changing members is not allowed." %}{% endif %}"><span class="icon-remove-sign"></span></a>
+      <a class="{% if not row.record.can_manage_members %} disabled {% else %} js-remove-object {% endif %}" data-confirm="{% blocktrans with name=row.record.name username=table.context.object.get_full_name %}Do you really want to remove role &quot;{{ name }}&quot; from user &quot;{{ username }}&quot;?{% endblocktrans %}" href="#" data-pk-arg="role" title="{% if not row.record.can_manage_members %}{% trans "This role is synchronised from LDAP, changing members is not allowed." %}{% endif %}"><span class="icon-remove-sign"></span></a>
     {% endif %}
   </td>
   {% endblock %}
-- 
2.28.0